debugfs: fix debugfs_rename parameter checking
[linux/fpc-iii.git] / tools / testing / selftests / memory-hotplug / mem-on-off-test.sh
blobb37585e6aa386829d701b02983d51f7353ac507f
1 #!/bin/bash
2 # SPDX-License-Identifier: GPL-2.0
4 SYSFS=
6 # Kselftest framework requirement - SKIP code is 4.
7 ksft_skip=4
9 prerequisite()
11 msg="skip all tests:"
13 if [ $UID != 0 ]; then
14 echo $msg must be run as root >&2
15 exit $ksft_skip
18 SYSFS=`mount -t sysfs | head -1 | awk '{ print $3 }'`
20 if [ ! -d "$SYSFS" ]; then
21 echo $msg sysfs is not mounted >&2
22 exit $ksft_skip
25 if ! ls $SYSFS/devices/system/memory/memory* > /dev/null 2>&1; then
26 echo $msg memory hotplug is not supported >&2
27 exit $ksft_skip
30 if ! grep -q 1 $SYSFS/devices/system/memory/memory*/removable; then
31 echo $msg no hot-pluggable memory >&2
32 exit $ksft_skip
37 # list all hot-pluggable memory
39 hotpluggable_memory()
41 local state=${1:-.\*}
43 for memory in $SYSFS/devices/system/memory/memory*; do
44 if grep -q 1 $memory/removable &&
45 grep -q $state $memory/state; then
46 echo ${memory##/*/memory}
48 done
51 hotpluggable_offline_memory()
53 hotpluggable_memory offline
56 hotpluggable_online_memory()
58 hotpluggable_memory online
61 memory_is_online()
63 grep -q online $SYSFS/devices/system/memory/memory$1/state
66 memory_is_offline()
68 grep -q offline $SYSFS/devices/system/memory/memory$1/state
71 online_memory()
73 echo online > $SYSFS/devices/system/memory/memory$1/state
76 offline_memory()
78 echo offline > $SYSFS/devices/system/memory/memory$1/state
81 online_memory_expect_success()
83 local memory=$1
85 if ! online_memory $memory; then
86 echo $FUNCNAME $memory: unexpected fail >&2
87 return 1
88 elif ! memory_is_online $memory; then
89 echo $FUNCNAME $memory: unexpected offline >&2
90 return 1
92 return 0
95 online_memory_expect_fail()
97 local memory=$1
99 if online_memory $memory 2> /dev/null; then
100 echo $FUNCNAME $memory: unexpected success >&2
101 return 1
102 elif ! memory_is_offline $memory; then
103 echo $FUNCNAME $memory: unexpected online >&2
104 return 1
106 return 0
109 offline_memory_expect_success()
111 local memory=$1
113 if ! offline_memory $memory; then
114 echo $FUNCNAME $memory: unexpected fail >&2
115 return 1
116 elif ! memory_is_offline $memory; then
117 echo $FUNCNAME $memory: unexpected offline >&2
118 return 1
120 return 0
123 offline_memory_expect_fail()
125 local memory=$1
127 if offline_memory $memory 2> /dev/null; then
128 echo $FUNCNAME $memory: unexpected success >&2
129 return 1
130 elif ! memory_is_online $memory; then
131 echo $FUNCNAME $memory: unexpected offline >&2
132 return 1
134 return 0
137 error=-12
138 priority=0
139 # Run with default of ratio=2 for Kselftest run
140 ratio=2
141 retval=0
143 while getopts e:hp:r: opt; do
144 case $opt in
146 error=$OPTARG
149 echo "Usage $0 [ -e errno ] [ -p notifier-priority ] [ -r percent-of-memory-to-offline ]"
150 exit
153 priority=$OPTARG
156 ratio=$OPTARG
157 if [ "$ratio" -gt 100 ] || [ "$ratio" -lt 0 ]; then
158 echo "The percentage should be an integer within 0~100 range"
159 exit 1
162 esac
163 done
165 if ! [ "$error" -ge -4095 -a "$error" -lt 0 ]; then
166 echo "error code must be -4095 <= errno < 0" >&2
167 exit 1
170 prerequisite
172 echo "Test scope: $ratio% hotplug memory"
175 # Online all hot-pluggable memory
177 hotpluggable_num=`hotpluggable_offline_memory | wc -l`
178 echo -e "\t online all hot-pluggable memory in offline state:"
179 if [ "$hotpluggable_num" -gt 0 ]; then
180 for memory in `hotpluggable_offline_memory`; do
181 echo "offline->online memory$memory"
182 if ! online_memory_expect_success $memory; then
183 retval=1
185 done
186 else
187 echo -e "\t\t SKIPPED - no hot-pluggable memory in offline state"
191 # Offline $ratio percent of hot-pluggable memory
193 hotpluggable_num=`hotpluggable_online_memory | wc -l`
194 target=`echo "a=$hotpluggable_num*$ratio; if ( a%100 ) a/100+1 else a/100" | bc`
195 echo -e "\t offline $ratio% hot-pluggable memory in online state"
196 echo -e "\t trying to offline $target out of $hotpluggable_num memory block(s):"
197 for memory in `hotpluggable_online_memory`; do
198 if [ "$target" -gt 0 ]; then
199 echo "online->offline memory$memory"
200 if offline_memory_expect_success $memory; then
201 target=$(($target - 1))
204 done
205 if [ "$target" -gt 0 ]; then
206 retval=1
207 echo -e "\t\t FAILED - unable to offline some memory blocks, device busy?"
211 # Online all hot-pluggable memory again
213 hotpluggable_num=`hotpluggable_offline_memory | wc -l`
214 echo -e "\t online all hot-pluggable memory in offline state:"
215 if [ "$hotpluggable_num" -gt 0 ]; then
216 for memory in `hotpluggable_offline_memory`; do
217 echo "offline->online memory$memory"
218 if ! online_memory_expect_success $memory; then
219 retval=1
221 done
222 else
223 echo -e "\t\t SKIPPED - no hot-pluggable memory in offline state"
227 # Test with memory notifier error injection
230 DEBUGFS=`mount -t debugfs | head -1 | awk '{ print $3 }'`
231 NOTIFIER_ERR_INJECT_DIR=$DEBUGFS/notifier-error-inject/memory
233 prerequisite_extra()
235 msg="skip extra tests:"
237 /sbin/modprobe -q -r memory-notifier-error-inject
238 /sbin/modprobe -q memory-notifier-error-inject priority=$priority
240 if [ ! -d "$DEBUGFS" ]; then
241 echo $msg debugfs is not mounted >&2
242 exit $retval
245 if [ ! -d $NOTIFIER_ERR_INJECT_DIR ]; then
246 echo $msg memory-notifier-error-inject module is not available >&2
247 exit $retval
251 echo -e "\t Test with memory notifier error injection"
252 prerequisite_extra
255 # Offline $ratio percent of hot-pluggable memory
257 echo 0 > $NOTIFIER_ERR_INJECT_DIR/actions/MEM_GOING_OFFLINE/error
258 for memory in `hotpluggable_online_memory`; do
259 if [ $((RANDOM % 100)) -lt $ratio ]; then
260 offline_memory_expect_success $memory
262 done
265 # Test memory hot-add error handling (offline => online)
267 echo $error > $NOTIFIER_ERR_INJECT_DIR/actions/MEM_GOING_ONLINE/error
268 for memory in `hotpluggable_offline_memory`; do
269 online_memory_expect_fail $memory
270 done
273 # Online all hot-pluggable memory
275 echo 0 > $NOTIFIER_ERR_INJECT_DIR/actions/MEM_GOING_ONLINE/error
276 for memory in `hotpluggable_offline_memory`; do
277 online_memory_expect_success $memory
278 done
281 # Test memory hot-remove error handling (online => offline)
283 echo $error > $NOTIFIER_ERR_INJECT_DIR/actions/MEM_GOING_OFFLINE/error
284 for memory in `hotpluggable_online_memory`; do
285 offline_memory_expect_fail $memory
286 done
288 echo 0 > $NOTIFIER_ERR_INJECT_DIR/actions/MEM_GOING_OFFLINE/error
289 /sbin/modprobe -q -r memory-notifier-error-inject
291 exit $retval